<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'"
				 label-width="160px" @submit.native.prevent>
			<el-divider content-position="left"><i class="el-icon-document"></i>
				借款申请
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="12">
					<el-form-item label="还款人" prop="createName"
								  :rules="[]">
						<el-input :disabled="true" v-model="inputForm.createName"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="还款时间" prop="createTime"
								  :rules="[]">
						<el-input :disabled="true" v-model="inputForm.createTime"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="还款金额(小写)" prop="refundLower"
								  :rules="[{required: true, message:'请输入还款金额(小写)', trigger:'blur'}]">
						<el-input v-on:input="inputForm.refundLower=inputForm.refundLower.replace(/[^\d.]/g,'')
							  .replace(/^\./g,'')
							  .replace(/\.{2,}/g,'.')
							  .replace('.','$#$').replace(/\./g,'').replace('$#$','.')
							  .replace(/^(\-)*(\d+)\.(\d\d).*$/,'$1$2.$3').replace(/^0+/, '0')" @blur="convert(this.inputForm.refundLower)" :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" placeholder="请输入还款金额" v-model="inputForm.refundLower" clearable></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="还款金额(大写)" prop="refund"
								  :rules="[]">
						<el-input :disabled="true" v-model="inputForm.refund"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="剩余借款金额" prop="finalMoney"
								  :rules="[]">
						<el-input :disabled="true" v-model="inputForm.finalMoney"></el-input>
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
	</div>
</template>

<script>
	import XEUtils from 'xe-utils'
	import BorrowService from '@/api/jy/BorrowService'
	import { ElDatePicker } from 'element-plus';
	import CommonApi from '@/api/cw/common/CommonApi'
	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				loading: false,
				inputForm: {
					id: '',
					no: '',
					createById: '',
					createName: this.$store.state.user.name,
					createTime: this.moment(new Date()).format('YYYY-MM-DD'),
					reason: '',
					refundLower:'', // 还款金额小写
					moneyLower:'', // 借款金额小写
					refund:'', //借款金额大写
					procInsId:'',
					status:'',
					finalMoney:'',
					endMoney:'',
					refundId:''
				},
				baseKey: '',
				keyWatch: '',
				dateList:[]
			}
		},
		BorrowService:null,
		CommonApi:null,
		created () {
			this.borrowService=new BorrowService()
			this.commonApi = new CommonApi()
		},
		mounted () {
		},
		activated () {
		},
		components: {
			ElDatePicker
		},
		computed: {
			bus: {
				get () {
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.bus) {
						if (this.bus !== 'false') {
							this.init('', this.bus)
						}
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
				}
			}
		},
		methods: {
			getKeyWatch(keyWatch) {
				this.keyWatch = keyWatch
			},
			init(method, id) {
				this.method = method
				this.inputForm={
					id: '',
					no: '',
					createById: this.$store.state.user.id,
					createName: this.$store.state.user.name,
					createTime: this.moment(new Date()).format('YYYY-MM-DD'),
					reason: '',
					refundLower:'', // 还款金额小写
					refund:'', //还款金额大写
					procInsId:'',
					finalMoney:'',
					moneyLower:'', // 借款金额小写
					endMoney:'',
					refundId:''
				}
				this.inputForm.id = id
				this.loading = false
				this.$nextTick(() => {
					this.$refs.inputForm.resetFields()
					this.loading = true
					if (this.commonJS.isNotEmpty(this.inputForm.id)) {
						console.log('this.inputForm.id', this.inputForm.id)
						this.borrowService.findByRefundId(this.inputForm.id).then((data)=>{
							this.inputForm = this.recover(this.inputForm, data)
							this.inputForm.id=data.refundId
							if (this.commonJS.isEmpty(this.inputForm.createName)){
								this.inputForm.createName=this.$store.state.user.name
							}
							if (this.commonJS.isEmpty(this.inputForm.officeName)){
								this.inputForm.officeName=this.$store.state.user.office.name							}
							if (this.commonJS.isEmpty(this.inputForm.createTime)){
								this.inputForm.createTime=this.moment(new Date()).format('YYYY-MM-DD')
							}
							this.inputForm.endMoney=data.finalMoney
							console.log('data',data)
							if (data.boMoney<data.finalMoney ){
								this.inputForm.finalMoney = data.boMoney
								this.inputForm.endMoney=data.boMoney
							}
							console.log('status',this.status)
							if (data.refundStatus === '5' && this.status !== 'audit' && this.status !== 'taskFormDetail'){
								this.inputForm.refundLower = ''
							}
							if (data.refundStatus === '1'){
								this.borrowService.findByBorId(data.refundId).then((da)=>{
									console.log('da',da)
									if (da.length === 0){
										this.inputForm.finalMoney = data.boMoney
										this.inputForm.endMoney=data.moneyLower
									}else {
										let money = 0
										for (let i = 0; i < da.length; i++) {
											money += parseFloat(da[i].refundMoney)
										}
										 let money1=parseFloat(data.moneyLower)
										let money2 = money1 - money
										this.inputForm.finalMoney = money2
										this.inputForm.endMoney=money2
									}
								})

							}
						})
						this.loading = false
					}
				})
			},
			saveForm(callback) {
				this.doSubmit('save', callback)
			},
			startForm(callback) {
				this.loading = true
				if (this.commonJS.isNotEmpty(this.inputForm.id)) {
					this.borrowService.queryById(this.inputForm.id).then((data) => {
						if (data.refundStatus !== '0' && data.refundStatus !== '1' && data.refundStatus !== '3' && data.refundStatus !== '5' && data.refundStatus !== '' && data.refundStatus !== null && data.refundStatus !== undefined) { // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							this.doSubmit('start', callback)
						}
					})
				} else {
					this.doSubmit('start', callback)
				}
			},
			async agreeForm(callback) {
				console.log('进入方法')
				this.loading = true
				await this.borrowService.queryById(this.inputForm.id).then((data) => {
					if (data.refundStatus !== '2' ) { // status的值不等于“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error()
					} else {
						this.inputForm.status= '5'
						let param = {status: this.inputForm.status, id: this.inputForm.id}
						this.borrowService.updateRefundById(param).then(() => {
							callback(data.businessTable, data.businessId, this.inputForm)
							this.loading = false
						}).catch(() => {
							this.loading = false
						})
					}
				})
			},
			reapplyForm(callback) {
				this.loading = true
				this.borrowService.queryById(this.inputForm.id).then((data) => {
					if (data.refundStatus !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.doSubmit('reapply', callback)
					}
				})
			},
			// 表单提交
			async doSubmit(status, callback) {
				this.loading = true
				console.log('5',this.inputForm)
				if (status === 'save') {
					// 暂存
					this.loading = true
					this.inputForm.status = '1'
					this.inputForm.createTime=''
					this.borrowService.saveRefund(this.inputForm).then((data) => {
						callback(data.businessTable, data.businessId, this.inputForm)
						this.loading = false
					}).catch(() => {
						this.loading = false
					})
					return
				} else if (status === 'start') {
					if (this.commonJS.isEmpty(this.inputForm.reason)) {
						this.$message.error('请输入借款用途')
						this.loading = false
					}
					if (this.commonJS.isEmpty(this.inputForm.moneyLower)) {
						this.$message.error('请输入借款金额')
						this.loading = false
					}
					this.inputForm.createTime=''
					// 送审  待审核
					this.inputForm.status = '2'
				} else if (status === 'agree') {
					this.inputForm.status= '5'
				} else if (status === 'reapply') {
					this.inputForm.status = '2'
				}
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true
						console.log('form',this.inputForm)
						this.borrowService.saveRefund(this.inputForm).then((data) => {
							callback(data.businessTable, data.businessId, this.inputForm)
							this.$refs.inputForm.resetFields()
							this.loading = false
						}).catch(() => {
							this.$refs.inputForm.resetFields()
							this.loading = false
						})
					} else {
						this.loading = false
					}
				})
			},
			close() {
				this.inputForm = {
					id: '',
					no: '',
					createById: '',
					createName: '',
					createTime: '',
					reason: '',
					refundLower:'', // 还款金额小写
					refund:'', //还款金额大写
					procInsId:'',
					finalMoney:'',
					moneyLower:'', // 借款金额小写
					endMoney:'',
					refundId:''
				}
				this.visible = false
			},
			async updateStatusById(type, callback) {
				this.loading = true
				if (type === 'reject' || type === 'reback') {
					this.borrowService.queryById(this.inputForm.id).then((data) => {
						if (data.refundStatus !== '2') { // status的值不等于“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// if (type === 'agree') {
							//   // 同意
							//   this.inputForm.status = '5'
							// }
							if (type === 'reject') {
								// 驳回
								this.inputForm.status = '4'
							}
							if (type === 'reback') {
								// 撤回
								this.inputForm.status = '3'
							}
							if (type === 'reject' || type === 'reback') {
								let param = {status: this.inputForm.status, id: this.inputForm.id}
								this.borrowService.updateRefundById(param).then(() => {
									this.loading = false
									callback()
								})
							}
						}
					})
				} else if (type === 'hold') {
					this.borrowService.queryById(this.inputForm.id).then((data) => {
						if (data.refundStatus !== '4') { // status的值不等于“驳回”就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// 终止
							let param = {status: '1', id: this.inputForm.id}
							this.borrowService.updateRefundById(param).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}

			},
			convert(money){
				if (!money) {
					if (this.commonJS.isEmpty(money)){
						this.inputForm.finalMoney=this.inputForm.endMoney
					}
					return this.inputForm.refund='';}
				//数字的汉字数组
				let numberCNList = ['零', '壹', '贰', '叁', '肆', '伍', '陆', '柒', '捌', '玖'];
				//数字的基础单位汉字数组
				let numberBaseUnit = ['', '拾', '佰', '仟'];
				//数字的高级单位汉字数组
				let numberHighUnit = ['', '万', '亿', '兆'];// 一兆等于一万亿
				//小数部分单位汉字数组
				let floatUnit = ['角', '分', '毫', '厘'];
				//整数金额时后面跟的字符
				let integerLastCN = '整';
				//整数后的单位汉字
				let integerLastUnit = '元';
				//最大处理的数字
				let maxNum = 999999999999999.9999;
				//以小数点拆分金额产生的数组
				let decimalPointSplitList;
				//金额整数部分
				let integerNum;
				//金额小数部分
				let decimalNum;
				//返回的大写金额
				let moneyCNString = '';
				money = parseFloat(money);// 转为数字
				if(typeof money !== 'number' || isNaN(money)){this.$message('检测到非数字字符');return '';}
				//超出最大处理数字
				if (money >= maxNum) {this.$message('超出最大处理数字');return '';}
				// 等于0时 返回零元整
				if (money === 0) {
					moneyCNString = numberCNList[0] + integerLastUnit + integerLastCN;
					return moneyCNString;
				}
				//转换为字符串
				money = money.toString();
				/******金额数字的处理，转为字符串，判断有没有小数位，获取整数部分和小数部分*******/
				if (money.indexOf('.') === -1) {// 如果没有小数点
					integerNum = money;// money就都等于整数部分，小数部分为空
					decimalNum = '';
				} else {// 有小数点
					decimalPointSplitList = money.split('.');// 以小数点拆分数组
					if(decimalPointSplitList[1].length > 4)this.$message('金额精确仅支持到厘');
					integerNum = decimalPointSplitList[0];// 整数部分
					decimalNum = decimalPointSplitList[1].substr(0, 4);// 小数部分只支持4位
				}
				/******整数部分处理*******/
				if (parseInt(integerNum, 10) > 0) {// 以十进制转为int类型 大于零
					let zeroCount = 0;// 记录零的个数
					for (let i = 0; i < integerNum.length; i++) {
						let p = integerNum.length - 1 - i;// 当前数字的位数, 比如10000 ，1的位数是4 ， 10001000，第一个1的位数是7，第二个1的位数是3
						console.log(p,integerNum[i]);
						let q = p / 4;// 当前数字位数 除以 4 商0余1，则值为0，控制其高级单位
						let m = p % 4;// 取余,比如1%4 商0余1 ，则值为1， 控制其基础单位
						// 如果当前数字等于零 则++
						if (integerNum[i] === '0') {zeroCount++;}
						// 否则当前数字不等于零时
						else {
							// 如果记录的零的个数大于0 返回结果中加一个汉字零
							if (zeroCount > 0) {moneyCNString += numberCNList[0];}
							//把零的个数归零，重新计算零的个数
							zeroCount = 0;
							// 然后把返回结果 加上 当前数字的汉字以及其基础单位
							moneyCNString += numberCNList[parseInt(integerNum[i])] + numberBaseUnit[m];
						}
						// 如果当前数字所在位数取余4等于0时，那么除以4一定是整数，并且记录的零的个数小于4个,则拼接当前位数对应的高级单位
						if (m === 0 && zeroCount < 4) {moneyCNString += numberHighUnit[q];}
					}
					moneyCNString += integerLastUnit;// 整数部分结束后 拼接上整数部分单位 元
				}
				/******小数部分处理 --- 小数部分只考虑是否有值，以及当前值所在单位，没有零的概念，所以只需拼接当前值对应的汉字，以及当前值的单位即可*******/
				if (decimalNum !== '') {
					for (let i = 0; i < decimalNum.length; i++) {
						if (decimalNum[i] !== '0') {// 如果当前数字不等于零 则加上当前数字的汉字 以及 其小数单位
							moneyCNString += numberCNList[Number(decimalNum[i])] + floatUnit[i];
						}
					}
				}else {// 如果没有小数部分则加上汉字 整
					moneyCNString += integerLastCN;
				}

				this.inputForm.refund= moneyCNString;
				this.inputForm.finalMoney=parseFloat(this.inputForm.endMoney-money)
				if (this.inputForm.finalMoney <0){
					this.$message.error("还款金额不正确")
					throw new Error()
					this.inputForm.refundLower=''
					this.inputForm.finalMoney=this.inputForm.endMoney
				}

			}


		}

	}
</script>
<style scoped>
	/deep/ .el-input-number .el-input__inner {
		text-align: left;
	}
	/deep/ .vxe-footer--row .vxe-footer--column:nth-child(1) .vxe-cell--item {
		font-weight:700;
	}
</style>
